Index: trunk/ICeCoffEE/ICeCoffEE/ICeCoffEE.xcodeproj/nicholas.pbxuser
===================================================================
--- trunk/ICeCoffEE/ICeCoffEE/ICeCoffEE.xcodeproj/nicholas.pbxuser	(revision 318)
+++ trunk/ICeCoffEE/ICeCoffEE/ICeCoffEE.xcodeproj/nicholas.pbxuser	(revision 319)
@@ -1426,7 +4273,7 @@
 	E1ABAEB80812F4B2007C5427 /* Info-APE Module.plist */ = {
 		uiCtxt = {
-			sepNavIntBoundsRect = "{{0, 0}, {707, 456}}";
+			sepNavIntBoundsRect = "{{0, 0}, {707, 474}}";
 			sepNavSelRange = "{980, 0}";
-			sepNavVisRect = "{{0, 0}, {707, 453}}";
+			sepNavVisRect = "{{0, 0}, {707, 473}}";
 			sepNavWindowFrame = "{{200, 163}, {746, 511}}";
 		};
@@ -1437,7 +4284,7 @@
 	E1ABAED40812F4B2007C5427 /* Info-APEManagerPrefPane.plist */ = {
 		uiCtxt = {
-			sepNavIntBoundsRect = "{{0, 0}, {748, 585}}";
+			sepNavIntBoundsRect = "{{0, 0}, {748, 606}}";
 			sepNavSelRange = "{761, 0}";
-			sepNavVisRect = "{{0, 0}, {748, 585}}";
+			sepNavVisRect = "{{0, 0}, {748, 605}}";
 			sepNavWindowFrame = "{{429, 103}, {787, 643}}";
 		};
@@ -1474,7 +4321,7 @@
 	E1ABAEF00812F4B3007C5427 /* Info-ICeCoffEE Installer.plist */ = {
 		uiCtxt = {
-			sepNavIntBoundsRect = "{{0, 0}, {748, 585}}";
+			sepNavIntBoundsRect = "{{0, 0}, {748, 606}}";
 			sepNavSelRange = "{790, 0}";
-			sepNavVisRect = "{{0, 0}, {748, 585}}";
+			sepNavVisRect = "{{0, 0}, {748, 605}}";
 			sepNavWindowFrame = "{{452, 103}, {787, 643}}";
 		};
@@ -1617,7 +4464,7 @@
 	E1CBC99803E7602700050002 /* English */ = {
 		uiCtxt = {
-			sepNavIntBoundsRect = "{{0, 0}, {748, 1392}}";
-			sepNavSelRange = "{0, 0}";
-			sepNavVisRect = "{{0, 0}, {748, 585}}";
+			sepNavIntBoundsRect = "{{0, 0}, {748, 1322}}";
+			sepNavSelRange = "{311, 0}";
+			sepNavVisRect = "{{0, 0}, {748, 605}}";
 			sepNavWindowFrame = "{{475, 103}, {787, 643}}";
 		};
@@ -1629,4 +4476,69 @@
 			sepNavVisRect = "{{0, 347}, {585, 566}}";
 		};
+	};
+	E1FC8DC00C1A2DC70021AB09 /* PBXTextBookmark */ = {
+		isa = PBXTextBookmark;
+		fRef = E14343B303DB4CF200050002 /* ICeCoffEE.h */;
+		name = "ICeCoffEE.h: 10";
+		rLen = 0;
+		rLoc = 486;
+		rType = 0;
+		vrLen = 2268;
+		vrLoc = 0;
+	};
+	E1FC8DC10C1A2DC70021AB09 /* PBXTextBookmark */ = {
+		isa = PBXTextBookmark;
+		fRef = E14343B403DB4CF200050002 /* ICeCoffEE.m */;
+		name = "IconRef ICCF_CopyIconRefForPath(NSString *path) {";
+		rLen = 0;
+		rLoc = 17466;
+		rType = 0;
+		vrLen = 2958;
+		vrLoc = 16794;
+	};
+	E1FC8DC20C1A2DC70021AB09 /* PBXTextBookmark */ = {
+		isa = PBXTextBookmark;
+		fRef = E14343B403DB4CF200050002 /* ICeCoffEE.m */;
+		name = "IconRef ICCF_CopyIconRefForPath(NSString *path) {";
+		rLen = 0;
+		rLoc = 17466;
+		rType = 0;
+		vrLen = 2958;
+		vrLoc = 16794;
+	};
+	E1FC8DC30C1A2DC70021AB09 /* PBXTextBookmark */ = {
+		isa = PBXTextBookmark;
+		fRef = E14343B303DB4CF200050002 /* ICeCoffEE.h */;
+		name = "ICeCoffEE.h: 10";
+		rLen = 0;
+		rLoc = 486;
+		rType = 0;
+		vrLen = 2268;
+		vrLoc = 0;
+	};
+	E1FC8F260C1A3C530021AB09 /* ICeCoffEELabeledIconCell.h */ = {
+		uiCtxt = {
+			sepNavIntBoundsRect = "{{0, 0}, {802, 930}}";
+			sepNavSelRange = "{395, 0}";
+			sepNavVisRect = "{{0, 0}, {802, 929}}";
+		};
+	};
+	E1FC8F270C1A3C530021AB09 /* ICeCoffEELabeledIconCell.m */ = {
+		uiCtxt = {
+			sepNavIntBoundsRect = "{{0, 0}, {802, 1397}}";
+			sepNavSelRange = "{1076, 0}";
+			sepNavVisRect = "{{0, 0}, {802, 929}}";
+			sepNavWindowFrame = "{{756, 61}, {841, 967}}";
+		};
+	};
+	E1FC90EC0C1A56690021AB09 /* PBXTextBookmark */ = {
+		isa = PBXTextBookmark;
+		fRef = E14343B403DB4CF200050002 /* ICeCoffEE.m */;
+		name = "ICeCoffEE.m: UNICHAR_BLACK_RIGHT_POINTING_SMALL_TRIANGLE";
+		rLen = 0;
+		rLoc = 17466;
+		rType = 0;
+		vrLen = 3065;
+		vrLoc = 16794;
 	};
 	F56276BA03796C8B01AA4DA5 /* CFPreferencesWrapper.m */ = {
@@ -1640,8 +4552,8 @@
 	F56276C20379923401AA4DA5 /* English */ = {
 		uiCtxt = {
-			sepNavIntBoundsRect = "{{0, 0}, {715, 6298}}";
-			sepNavSelRange = "{0, 0}";
-			sepNavVisRect = "{{0, 0}, {715, 688}}";
-			sepNavWindowFrame = "{{104, 0}, {754, 746}}";
+			sepNavIntBoundsRect = "{{0, 0}, {715, 6362}}";
+			sepNavSelRange = "{7662, 0}";
+			sepNavVisRect = "{{0, 2468}, {715, 708}}";
+			sepNavWindowFrame = "{{856, 25}, {754, 746}}";
 		};
 	};
@@ -1656,7 +4568,7 @@
 	F9A6986E03BE1DF000AA4DA5 /* APEMain.m */ = {
 		uiCtxt = {
-			sepNavIntBoundsRect = "{{0, 0}, {713, 3768}}";
-			sepNavSelRange = "{707, 0}";
-			sepNavVisRect = "{{0, 0}, {713, 596}}";
+			sepNavIntBoundsRect = "{{0, 0}, {813, 3470}}";
+			sepNavSelRange = "{13167, 26}";
+			sepNavVisRect = "{{0, 3174}, {813, 296}}";
 			sepNavWindowFrame = "{{69, -4}, {752, 654}}";
 		};
Index: trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEKeyEquivalents.m
===================================================================
--- trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEKeyEquivalents.m	(revision 318)
+++ trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEKeyEquivalents.m	(revision 319)
@@ -40,4 +40,5 @@
 static NSFont *menuItemCmdKeyFont = nil;
 static NSFont *menuItemFont = nil;
+static NSFont *collisionFont = nil;
 static NSParagraphStyle *keyEquivParaStyle;
 
@@ -47,4 +48,5 @@
     menuItemCmdKeyFont = [themeFont(kThemeMenuItemCmdKeyFont) retain];
     menuItemFont = [themeFont(kThemeMenuItemFont) retain];
+    collisionFont = [themeFont(kThemeSmallSystemFont) retain];
 
     NSMutableParagraphStyle *paraStyle = [[NSMutableParagraphStyle alloc] init];
@@ -108,5 +110,5 @@
 }
 
-NSAttributedString *ICCF_KeyEquivalentAttributedStringWithModifierFlags(NSString *self, unsigned int modifierFlags) {
+NSAttributedString *ICCF_KeyEquivalentAttributedStringWithModifierFlags(NSString *self, unsigned int modifierFlags, unsigned count) {
     initialize();
     NSString *keyEquivalentStringNoMask = keyEquivalentString(self);
@@ -128,4 +130,12 @@
         [astr release];
     }
+    if (count > 1) {
+	NSMutableAttributedString *astr = [keyEquivalentAttributedString mutableCopy];
+	[astr appendAttributedString: [[[NSAttributedString alloc]
+	    initWithString: [NSString stringWithFormat: @" (%u)", count]
+		attributes: [NSDictionary dictionaryWithObjectsAndKeys: collisionFont, NSFontAttributeName, [NSColor redColor], NSForegroundColorAttributeName, nil]] autorelease]];
+        keyEquivalentAttributedString = [[astr copy] autorelease];
+        [astr release];
+    }
     return keyEquivalentAttributedString;
 }
Index: trunk/ICeCoffEE/ICeCoffEE/ICeCoffEELabeledIconCell.h
===================================================================
--- trunk/ICeCoffEE/ICeCoffEE/ICeCoffEELabeledIconCell.h	(revision 319)
+++ trunk/ICeCoffEE/ICeCoffEE/ICeCoffEELabeledIconCell.h	(revision 319)
@@ -0,0 +1,22 @@
+//
+//  ICeCoffEELabeledIconCell.h
+//  ICeCoffEE
+//
+//  Created by Nicholas Riley on 6/8/07.
+//  Copyright 2007 Nicholas Riley. All rights reserved.
+//
+
+#import <ApplicationServices/ApplicationServices.h>
+#import "ICeCoffEENonHighlightingTextFieldCell.h"
+
+@interface ICeCoffEELabeledIconCell : ICeCoffEENonHighlightingTextFieldCell {
+@private
+    IconRef iconRef;
+}
+
++ (ICeCoffEELabeledIconCell *)copyFromTextFieldCell:(NSTextFieldCell *)cell;
+
+- (void)setIconRef:(IconRef)anIconRef;
+- (IconRef)iconRef;
+
+@end
Index: trunk/ICeCoffEE/ICeCoffEE/ICeCoffEELabeledIconCell.m
===================================================================
--- trunk/ICeCoffEE/ICeCoffEE/ICeCoffEELabeledIconCell.m	(revision 319)
+++ trunk/ICeCoffEE/ICeCoffEE/ICeCoffEELabeledIconCell.m	(revision 319)
@@ -0,0 +1,123 @@
+//
+//  ICeCoffEELabeledIconCell.m
+//  ICeCoffEE
+//
+//  Created by Nicholas Riley on 6/8/07.
+//  Copyright 2007 Nicholas Riley. All rights reserved.
+//
+
+#import "ICeCoffEELabeledIconCell.h"
+
+
+@implementation ICeCoffEELabeledIconCell
+
+const static float LEFT_PADDING = 3;
+const static float PADDING = 5;
+const static NSSize ICON_SIZE = {16, 16};
+
+- (ICeCoffEELabeledIconCell *)justCopySuper;
+{
+    return [super copy];
+}
+
++ (ICeCoffEELabeledIconCell *)copyFromTextFieldCell:(NSTextFieldCell *)cell;
+{
+    ((struct objc_object *)cell)->isa = self;
+    ICeCoffEELabeledIconCell *copy = [(ICeCoffEELabeledIconCell *)cell justCopySuper];
+    copy->iconRef = NULL;
+    ((struct objc_object *)cell)->isa = [NSTextFieldCell class];
+    return [copy autorelease];
+}
+
+- (void)dealloc;
+{
+    if (iconRef != NULL) {
+	ReleaseIconRef(iconRef);
+	iconRef = NULL;
+    }
+    [super dealloc];
+}
+
+- (id)copyWithZone:(NSZone *)zone;
+{
+    ICeCoffEELabeledIconCell *cell = [super copyWithZone: zone];
+    cell->iconRef = iconRef;
+    if (iconRef != NULL)
+	AcquireIconRef(iconRef);
+    return cell;
+}
+
+- (void)setIconRef:(IconRef)anIconRef;
+{
+    if (anIconRef == iconRef)
+	return;
+    if (iconRef != NULL)
+	ReleaseIconRef(iconRef);
+    if (anIconRef != NULL)
+	AcquireIconRef(anIconRef);
+    iconRef = anIconRef;
+}
+
+- (IconRef)iconRef;
+{
+    return iconRef;
+}
+
+- (void)editWithFrame:(NSRect)aRect inView:(NSView *)controlView editor:(NSText *)textObj delegate:(id)anObject event:(NSEvent *)theEvent;
+{
+    NSRect textFrame, imageFrame;
+    NSDivideRect(aRect, &imageFrame, &textFrame,
+                 PADDING + ICON_SIZE.width, NSMinXEdge);
+    [super editWithFrame: textFrame inView: controlView
+		  editor: textObj delegate: anObject event: theEvent];
+}
+
+- (void)selectWithFrame:(NSRect)aRect inView:(NSView *)controlView editor:(NSText *)textObj delegate:(id)anObject start:(int)selStart length:(int)selLength;
+{
+    NSRect textFrame, imageFrame;
+    NSDivideRect(aRect, &imageFrame, &textFrame, PADDING + ICON_SIZE.width,
+                 NSMinXEdge);
+    [super selectWithFrame: textFrame inView: controlView editor:textObj delegate: anObject start: selStart length: selLength];
+}
+
+- (void)drawWithFrame:(NSRect)cellFrame inView:(NSView *)controlView;
+{
+    if (iconRef != NULL) {
+        NSRect imageFrame;
+	BOOL flipped = [controlView isFlipped];
+	
+        NSDivideRect(cellFrame, &imageFrame, &cellFrame, PADDING + ICON_SIZE.width, NSMinXEdge);
+        if ([self drawsBackground]) {
+            [[self backgroundColor] set];
+            NSRectFill(imageFrame);
+        }
+        imageFrame.origin.x += LEFT_PADDING;
+        imageFrame.size = ICON_SIZE;
+	
+        imageFrame.origin.y += ceil((cellFrame.size.height + imageFrame.size.height + 2) / 2);
+
+	NSRect imageRect = NSOffsetRect(imageFrame, -imageFrame.origin.x, -imageFrame.origin.y);
+	CGContextRef context = (CGContextRef)[[NSGraphicsContext currentContext] graphicsPort];
+	CGContextTranslateCTM(context, imageFrame.origin.x, imageFrame.origin.y);
+	if (flipped)
+	    CGContextScaleCTM(context, 1, -1);
+	PlotIconRefInContext(context, (CGRect *)&imageRect, kAlignNone, kTransformNone,
+			     NULL /*inLabelColor*/, kPlotIconRefNormalFlags, iconRef);
+	if (flipped)
+	    CGContextScaleCTM(context, 1, -1);
+	CGContextTranslateCTM(context, -imageFrame.origin.x, -imageFrame.origin.y);
+    }
+    // XXX fix this
+    // [self setAttributedStringValue:
+    //     [[self stringValue] asAttributedStringTruncatedToWidth: cellFrame.size.width - 4]];
+    [super drawWithFrame: cellFrame inView: controlView];
+}
+
+- (NSSize)cellSize;
+{
+    NSSize cellSize = [super cellSize];
+    cellSize.width += (iconRef != NULL ? (ICON_SIZE.width + PADDING): 0);
+    return cellSize;
+}
+
+@end
Index: trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEServicePrefController.m
===================================================================
--- trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEServicePrefController.m	(revision 318)
+++ trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEServicePrefController.m	(revision 319)
@@ -12,4 +12,5 @@
 #import "ICeCoffEENonHighlightingButtonCell.h"
 #import "ICeCoffEENonHighlightingTextFieldCell.h"
+#import "ICeCoffEELabeledIconCell.h"
 #import <objc/objc.h>
 #import <ApplicationEnhancer/ApplicationEnhancer.h>
@@ -22,5 +23,51 @@
 }
 
-static inline NSCellStateValue ICCF_ServiceItemState(id <NSMenuItem> item) {
+static NSMutableDictionary *keyEquivalents;
+
+static void ICCF_RemoveSingleKeyEquivalents() {
+    NSMutableArray *singleKeys = [[NSMutableArray alloc] init];
+    NSEnumerator *e = [[keyEquivalents allKeys] objectEnumerator];
+    NSString *keyEquivalent;
+    ICLog(@"before ICCF_RemoveSingleKeyEquivalents: %@", keyEquivalents);
+    while ( (keyEquivalent = [e nextObject]) != nil) {
+	if ([[keyEquivalents objectForKey: keyEquivalent] count] == 1)
+	    [singleKeys addObject: keyEquivalent];
+    }
+    [keyEquivalents removeObjectsForKeys: singleKeys];
+    [singleKeys release];
+    ICLog(@"after ICCF_RemoveSingleKeyEquivalents: %@", keyEquivalents);
+}
+
+static inline unsigned ICCF_CountForKeyEquivalent(NSString *keyEquivalent) {
+    if (keyEquivalent == nil) return 0;
+    NSMutableSet *setOrNil = (NSMutableSet *)[keyEquivalents objectForKey: keyEquivalent];
+    return (setOrNil == nil) ? nil : [setOrNil count];
+}
+
+static inline void ICCF_AddKeyEquivalentForItem(NSMenuItem *item) {
+    NSString *keyEquivalent = [item toolTip];
+    if (keyEquivalent == nil) return;
+    NSMutableSet *setOrNil = (NSMutableSet *)[keyEquivalents objectForKey: keyEquivalent];
+    if (setOrNil == nil) return;
+    [setOrNil addObject: item];
+}
+
+static inline void ICCF_RemoveKeyEquivalentForItem(NSMenuItem *item) {
+    NSString *keyEquivalent = [item toolTip];
+    if (keyEquivalent == nil) return;
+    NSMutableSet *setOrNil = (NSMutableSet *)[keyEquivalents objectForKey: keyEquivalent];
+    if (setOrNil == nil) return;
+    [setOrNil removeObject: item];
+}
+
+static inline void ICCF_UpdateKeyEquivalentForItem(NSMenuItem *item, id state) {
+    NSNumber *oldState = [item representedObject];
+    if ((oldState == nil || oldState == ICCF_SERVICE_SHOWN) && state == ICCF_SERVICE_HIDDEN)
+	ICCF_RemoveKeyEquivalentForItem(item);
+    else if (oldState == ICCF_SERVICE_HIDDEN && (state == ICCF_SERVICE_SHOWN || state == nil))
+	ICCF_AddKeyEquivalentForItem(item);
+}
+
+static inline NSCellStateValue ICCF_ServiceItemState(NSMenuItem *item) {
     id state = [item representedObject];
     return (state == nil) ? NSOnState : [state intValue];
@@ -34,13 +81,14 @@
     while ( (item = [e nextObject]) != nil) {
         submenu = [item submenu];
-        if (submenu != nil) {
-            ICCF_PropagateServiceStateChange(submenu, state);
-            [item setRepresentedObject: (state == nil) ? ICCF_SERVICE_SHOWN : state];
-        }
-        [item setRepresentedObject: state];
-    }
-}
-
-static NSCellStateValue ICCF_PropagateServiceState(id <NSMenuItem> item, NSMenuItem *changedItem) {
+        if (submenu != nil)
+	    ICCF_PropagateServiceStateChange(submenu, state);
+	else
+	    ICCF_UpdateKeyEquivalentForItem(item, state);
+	
+	[item setRepresentedObject: state];
+    }
+}
+
+static NSCellStateValue ICCF_PropagateServiceState(NSMenuItem *item, NSMenuItem *changedItem) {
     NSMenu *submenu = [item submenu];
     if (submenu == nil) return ICCF_ServiceItemState(item);
@@ -102,14 +150,15 @@
     NSString *itemTitle;
     NSDictionary *subDict, *submenuDict;
-    id <NSMenuItem> item;
+    NSMenuItem *item;
     NSMenu *submenu;
 
     // XXX handle exceptions
     while ( (itemTitle = [e nextObject]) != nil) {
-        item = [menu itemWithTitle: itemTitle];
+        item = (NSMenuItem *)[menu itemWithTitle: itemTitle];
         if (item == nil) continue;
         subDict = [dict objectForKey: itemTitle];
         if ([[subDict objectForKey: (NSString *)kICServiceHidden] boolValue]) {
             [item setRepresentedObject: ICCF_SERVICE_HIDDEN];
+	    ICCF_RemoveKeyEquivalentForItem(item);
         }
         if ( (submenu = [item submenu]) != nil) {
@@ -123,4 +172,40 @@
 }
 
+static void ICCF_AddServiceKeyEquivalentsAndIcons(NSMenu *menu, NSDictionary *serviceInfo) {
+    if (serviceInfo == nil) return;
+    NSEnumerator *enumerator = [[menu itemArray] objectEnumerator];
+    NSMenuItem *menuItem;
+    NSMenu *submenu;
+    NSDictionary *itemInfo = nil;
+    while ( (menuItem = [enumerator nextObject]) != nil) {
+        itemInfo = [serviceInfo objectForKey: [menuItem title]];
+	if (itemInfo == nil) continue;
+	
+	if ( (submenu = [menuItem submenu]) != nil) {
+	    ICCF_AddServiceKeyEquivalentsAndIcons(submenu, itemInfo);
+	} else {
+	    NSString *keyEquivalent = (NSString *)[itemInfo objectForKey: (NSString *)kICServiceShortcut];
+	    if (keyEquivalent != nil) {
+		[menuItem setToolTip: keyEquivalent];
+		NSMutableSet *equivalentItems = (NSMutableSet *)[keyEquivalents objectForKey: keyEquivalent];
+		if (equivalentItems == nil) {
+		    equivalentItems = [[NSMutableSet alloc] initWithObjects: menuItem, nil];
+		    [keyEquivalents setObject: equivalentItems forKey: keyEquivalent];
+		    [equivalentItems release];
+		} else {
+		    [equivalentItems addObject: menuItem];
+		}
+	    }
+	}
+
+        NSString *bundlePath = (NSString *)[itemInfo objectForKey: (NSString *)kICServiceBundlePath];
+        if (bundlePath == NULL) continue;
+        IconRef serviceIcon = ICCF_CopyIconRefForPath(bundlePath);
+        if (serviceIcon == NULL) continue;
+        [menuItem _setIconRef: serviceIcon];
+        ReleaseIconRef(serviceIcon);
+    }
+}
+
 @implementation ICeCoffEEServicePrefController
 
@@ -141,4 +226,6 @@
     if ( (self = [self initWithWindowNibName: @"Select services"])) {
         NSWindow *window = [self window]; // connect outlets
+	[serviceOutline setAutoresizesOutlineColumn: NO];
+	
         NSButtonCell *checkBoxCell = [[ICeCoffEENonHighlightingButtonCell alloc] init];
         [checkBoxCell setButtonType: NSSwitchButton];
@@ -149,5 +236,7 @@
 
         NSTextFieldCell *textFieldCell = [[serviceOutline tableColumnWithIdentifier: @"service"] dataCell];
-        ((struct objc_object *)textFieldCell)->isa = [ICeCoffEENonHighlightingTextFieldCell class];
+	[textFieldCell setWraps: YES];
+	[[serviceOutline tableColumnWithIdentifier: @"service"] setDataCell:
+	    [ICeCoffEELabeledIconCell copyFromTextFieldCell: textFieldCell]];
 
         textFieldCell = [[serviceOutline tableColumnWithIdentifier: @"key"] dataCell];
@@ -167,4 +256,5 @@
 - (void)dealloc;
 {
+    [keyEquivalents release];
     [servicesMenu release];
     [super dealloc];
@@ -223,7 +313,10 @@
 {
     if (servicesMenu == nil) {
+	keyEquivalents = [[NSMutableDictionary alloc] init];
 	servicesMenu = [[NSMenu alloc] initWithTitle: @""];
 	ICCF_SetServicesMenu(servicesMenu);
-        [servicesMenu update]; // XXX necessary on 10.3? or anywhere?
+	ICCF_AddServiceKeyEquivalentsAndIcons(servicesMenu, ICCF_GetServicesInfo());
+	ICCF_RemoveSingleKeyEquivalents();
+	
         NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
         NSDictionary *icDefaults = [defaults persistentDomainForName: (NSString *)kICBundleIdentifier];
@@ -244,10 +337,17 @@
 }
 
-NSAttributedString *ICCF_KeyEquivalentAttributedStringWithModifierFlags(NSString *self, unsigned int modifierFlags);
+NSAttributedString *ICCF_KeyEquivalentAttributedStringWithModifierFlags(NSString *self, unsigned int modifierFlags, unsigned count);
 
 - (id)outlineView:(NSOutlineView *)outlineView objectValueForTableColumn:(NSTableColumn *)tableColumn byItem:(id)item;
 {
     if ([[tableColumn identifier] isEqualToString: @"service"]) {
-        return [item title];
+	static NSDictionary *attrDict = nil;
+	if (attrDict == nil) { // XXX we leak this, but so does the Apple sample code...
+	    NSMutableParagraphStyle *style = [[NSParagraphStyle defaultParagraphStyle] mutableCopy];
+	    [style setLineBreakMode: NSLineBreakByTruncatingMiddle];
+	    attrDict = [[NSDictionary alloc] initWithObjectsAndKeys: style, NSParagraphStyleAttributeName, nil];
+	    [style release];
+	}
+        return [[[NSAttributedString alloc] initWithString: [item title] attributes: attrDict] autorelease];
     } else if ([[tableColumn identifier] isEqualToString: @"show"]) {
         id state = [item representedObject];
@@ -257,9 +357,8 @@
         return (state == nil) ? ICCF_SERVICE_SHOWN : state;
     } else if ([[tableColumn identifier] isEqualToString: @"key"]) {
-        [item setKeyEquivalent: @"#"];
-        NSString *equivalent = [item keyEquivalent];
+        NSString *equivalent = [item toolTip];
         if (equivalent == nil || [equivalent length] != 1) return nil;
         // XXX Inconsistency between Cocoa and Carbon: always command-shift in Carbon, not in Cocoa.  Since we only patch Cocoa for the moment, keep as is.
-        return ICCF_KeyEquivalentAttributedStringWithModifierFlags(equivalent, [item keyEquivalentModifierMask] | ([[NSCharacterSet uppercaseLetterCharacterSet] characterIsMember: [equivalent characterAtIndex: 0]] ? NSShiftKeyMask : 0));
+        return ICCF_KeyEquivalentAttributedStringWithModifierFlags(equivalent, [item keyEquivalentModifierMask] | ([[NSCharacterSet uppercaseLetterCharacterSet] characterIsMember: [equivalent characterAtIndex: 0]] ? NSShiftKeyMask : 0), ICCF_CountForKeyEquivalent(equivalent));
     }
     return nil;
@@ -269,5 +368,7 @@
 {
     if ([[tableColumn identifier] isEqualToString: @"show"]) {
-        [item setRepresentedObject: [object boolValue] ? nil : ICCF_SERVICE_HIDDEN];
+	NSNumber *newState = [object boolValue] ? nil : ICCF_SERVICE_HIDDEN;
+	ICCF_UpdateKeyEquivalentForItem(item, newState);
+        [item setRepresentedObject: newState];
         
         NSMenu *submenu = [item menu];
@@ -279,8 +380,19 @@
                 submenu = supermenu;
             }
-            ICCF_PropagateServiceState([supermenu itemAtIndex: [supermenu indexOfItemWithSubmenu: submenu]], item);
+            ICCF_PropagateServiceState((NSMenuItem *)[supermenu itemAtIndex: [supermenu indexOfItemWithSubmenu: submenu]], item);
         }
         [outlineView reloadData];
     }
+}
+
+@end
+
+@implementation ICeCoffEEServicePrefController (NSOutlineViewDelegate)
+
+- (void)outlineView:(NSOutlineView *)outlineView willDisplayCell:(id)cell forTableColumn:(NSTableColumn *)tableColumn item:(id)item;
+{
+    if (![[tableColumn identifier] isEqualToString: @"service"])
+	return;
+    [(ICeCoffEELabeledIconCell *)cell setIconRef: [item _iconRef]];
 }
 
Index: trunk/ICeCoffEE/ICeCoffEE/ICeCoffEESetServicesMenu.h
===================================================================
--- trunk/ICeCoffEE/ICeCoffEE/ICeCoffEESetServicesMenu.h	(revision 318)
+++ trunk/ICeCoffEE/ICeCoffEE/ICeCoffEESetServicesMenu.h	(revision 319)
@@ -9,3 +9,12 @@
 #import <Cocoa/Cocoa.h>
 
+NSDictionary *ICCF_GetServicesInfo(void);
 void ICCF_SetServicesMenu(NSMenu *servicesMenu);
+
+IconRef ICCF_CopyIconRefForPath(NSString *path);
+
+// Cocoa additions
+@interface NSMenuItem (IC_IconRef)
+- (IconRef)_iconRef;
+- (void)_setIconRef:(IconRef)iconRef;
+@end
Index: trunk/ICeCoffEE/ICeCoffEE/ICeCoffEESetServicesMenu.m
===================================================================
--- trunk/ICeCoffEE/ICeCoffEE/ICeCoffEESetServicesMenu.m	(revision 318)
+++ trunk/ICeCoffEE/ICeCoffEE/ICeCoffEESetServicesMenu.m	(revision 319)
@@ -8,4 +8,115 @@
 
 #import "ICeCoffEESetServicesMenu.h"
+#import "ICeCoffEEShared.h"
+
+// XXX rename me to something like "ICeCoffEEServicesMenu.m"
+
+// an approximate clone of HIToolbox's CreateServicesLocalizedDictKey
+static CFStringRef preferredLocalization(CFDictionaryRef localizations) {
+    if (localizations == NULL)
+	return NULL;
+    
+    CFIndex localizationCount = CFDictionaryGetCount(localizations);
+    if (localizationCount == 0)
+	return NULL;
+    
+    const void **locales = malloc(localizationCount * sizeof(void *));
+    if (locales == NULL)
+	return NULL;
+    
+    CFDictionaryGetKeysAndValues(localizations, locales, NULL);
+    CFArrayRef availableLocales = CFArrayCreate(NULL, locales, localizationCount, NULL);
+    if (availableLocales == NULL)
+	return NULL;
+    
+    // XXX does this actually work in a localized app?
+    CFArrayRef preferredLocales = CFBundleCopyPreferredLocalizationsFromArray(availableLocales);
+    // NSLog(@"%@ => %@", availableLocales, preferredLocales);
+    CFRelease(availableLocales);
+    CFStringRef preferredLocalization;
+    if (preferredLocales != NULL) {
+	if (CFArrayGetCount(preferredLocales) > 0) {
+	    CFStringRef preferredLocale = CFArrayGetValueAtIndex(preferredLocales, 0);
+	    preferredLocalization = (CFStringRef)CFDictionaryGetValue(localizations, preferredLocale);
+	}
+	CFRelease(preferredLocales);
+    }
+    if (preferredLocalization == NULL) {
+	preferredLocalization = (CFStringRef)CFDictionaryGetValue(localizations, CFSTR("default"));
+	if (preferredLocalization == NULL)
+	    preferredLocalization = (CFStringRef)CFDictionaryGetValue(localizations, (CFStringRef)locales[0]);
+    }
+    
+    free(locales);
+    // NSLog(@"%@", preferredLocalization);
+    return preferredLocalization;
+}
+
+NSArray *CFServiceControllerCopyServicesEntries(void);
+
+NSDictionary *ICCF_GetServicesInfo(void) {
+    NSArray *services = CFServiceControllerCopyServicesEntries();
+    // NSLog(@"%@", services);
+    
+    NSEnumerator *e = [services objectEnumerator];
+    NSDictionary *serviceEntry;
+    NSMutableDictionary *serviceDict = [[NSMutableDictionary alloc] init];
+    while ( (serviceEntry = (NSDictionary *)[e nextObject]) != nil) {
+	// XXX once tested, redo all this with CF, and no autoreleasing
+	// XXX items named the same as submenus (figure out how Cocoa itself does it, too)
+	// XXX use kICServiceSubmenu (recursion?)
+	NSString *itemPath = (NSString *)preferredLocalization((CFDictionaryRef)[serviceEntry objectForKey: @"NSMenuItem"]);
+	if (itemPath == nil) continue;
+	
+	NSString *bundlePath = [serviceEntry objectForKey: @"NSBundlePath"];
+	BOOL bubbledUp = (bundlePath == nil);
+	NSArray *itemComponents = [itemPath componentsSeparatedByString: @"/"];
+	NSEnumerator *ce = [itemComponents objectEnumerator];
+	NSString *itemComponent;
+	NSMutableDictionary *levelDict = serviceDict;
+	NSMutableDictionary *itemDict = nil;
+	while ( (itemComponent = (NSString *)[ce nextObject]) != nil) {
+	    // itemDict is nil if just created
+	    if (itemDict != nil && !bubbledUp) {
+		NSString *oldBundlePath = [levelDict objectForKey: (NSString *)kICServiceBundlePath];
+		if ([oldBundlePath isEqualToString: bundlePath])
+		    bubbledUp = YES;
+		else if (oldBundlePath != nil) {
+		    [oldBundlePath retain];
+		    [levelDict removeObjectForKey: (NSString *)kICServiceBundlePath];
+		    NSEnumerator *be = [levelDict objectEnumerator];
+		    while ( (itemDict = (NSMutableDictionary *)[be nextObject]) != nil)
+			[itemDict setObject: oldBundlePath forKey: (NSString *)kICServiceBundlePath];
+		    [oldBundlePath release];
+		}
+	    }
+	    itemDict = [levelDict objectForKey: itemComponent];
+	    if (itemDict == nil) {
+		itemDict = [[NSMutableDictionary alloc] init];
+		if (!bubbledUp) {
+		    [itemDict setObject: bundlePath forKey: (NSString *)kICServiceBundlePath];
+		    bubbledUp = YES;
+		}
+		[levelDict setObject: itemDict forKey: itemComponent];
+		levelDict = itemDict;
+		[itemDict release];
+		itemDict = nil;
+	    } else {
+		levelDict = itemDict;
+	    }
+	}
+	
+	if (!bubbledUp)
+	    [levelDict setObject: bundlePath forKey: (NSString *)kICServiceBundlePath];
+
+	NSString *keyEquivalent = (NSString *)preferredLocalization((CFDictionaryRef)[serviceEntry objectForKey: @"NSKeyEquivalent"]);
+	if (keyEquivalent == nil) continue;
+
+	[levelDict setObject: keyEquivalent forKey: (NSString *)kICServiceShortcut];
+    }
+    [services release];
+    
+    return [serviceDict autorelease];
+}
 
 
@@ -31,2 +142,17 @@
     }
 }
+
+IconRef ICCF_CopyIconRefForPath(NSString *path) {
+    IconRef icon;
+    FSRef fsr;
+    SInt16 label;
+    OSStatus err = noErr;
+    
+    err = FSPathMakeRef((const UInt8 *)[path fileSystemRepresentation], &fsr, NULL);
+    if (err != noErr) return NULL;
+    
+    err = GetIconRefFromFileInfo(&fsr, 0, NULL, kFSCatInfoNone, NULL, kIconServicesNormalUsageFlag, &icon, &label);
+    if (err != noErr) return NULL;
+    
+    return icon;
+}
Index: trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEShared.h
===================================================================
--- trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEShared.h	(revision 318)
+++ trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEShared.h	(revision 319)
@@ -13,5 +13,5 @@
 #include <CoreFoundation/CoreFoundation.h>
 
-#define ICCF_DEBUG 0
+#define ICCF_DEBUG 1
 
 #if ICCF_DEBUG
@@ -46,8 +46,9 @@
 extern const CFStringRef kICErrorDialogEnabled; // CFNumber (Boolean)
 
-// kICServiceOptions dictionary keys
+// kICServiceOptions, ServiceInfo dictionary keys
 extern const CFStringRef kICServiceHidden; // CFNumber (Boolean)
-extern const CFStringRef kICServiceShortcut; // reserved for future use
+extern const CFStringRef kICServiceShortcut; // CFString
 extern const CFStringRef kICServiceSubmenu; // CFDictionary
+extern const CFStringRef kICServiceBundlePath; // CFString
 
 // APEBundleMessages
Index: trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEShared.m
===================================================================
--- trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEShared.m	(revision 318)
+++ trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEShared.m	(revision 319)
@@ -30,8 +30,9 @@
 const CFStringRef kICErrorDialogEnabled = (CFStringRef)@"ICErrorDialogEnabled"; // CFNumber (bool)
 
-// kICServiceOptions dictionary keys
+// kICServiceOptions, ServiceInfo dictionary keys
 const CFStringRef kICServiceSubmenu = (CFStringRef)@"ICServiceSubmenu"; // CFDictionary
 const CFStringRef kICServiceHidden = (CFStringRef)@"ICServiceHidden"; // CFNumber (Boolean)
-const CFStringRef kICServiceShortcut = (CFStringRef)@"ICServiceShortcut"; // reserved for future use
+const CFStringRef kICServiceShortcut = (CFStringRef)@"ICServiceShortcut"; // CFString
+const CFStringRef kICServiceBundlePath = (CFStringRef)@"ICServiceBundlePath"; // CFString
 
 // APEBundleMessages
